#ifndef _L4_THREAD_H
#define _L4_THREAD_H	1

#include <l4/types.h>
#include <l4/vregs.h>

#define l4_nilthread { .raw = 0 }
#define l4_anythread { .raw = (l4_word_t) -1 }
/* FIXME: When gcc supports unnamed fields as initializers, use them.  */
#define l4_anylocalthread { .local.local = -1, .local._all_zero = 0 }


#ifndef _L4_EXTERN_INLINE
#define _L4_EXTERN_INLINE extern __inline
#endif


_L4_EXTERN_INLINE l4_thread_id_t
l4_global_id (l4_word_t thread_no, l4_word_t version)
{
  l4_thread_id_t thread;

  thread.thread_no = thread_no;
  thread.version = version;

  return thread;
}


_L4_EXTERN_INLINE l4_word_t
l4_version (l4_thread_id_t thread)
{
  return thread.version;
}


_L4_EXTERN_INLINE l4_word_t
l4_thread_no (l4_thread_id_t thread)
{
  return thread.thread_no;
}


#if 0
_L4_EXTERN_INLINE l4_word_t
l4_same_threads (l4_thread_id_t thread1, l4_thread_id_t thread2)
{
  l4_thread_id_t global1 = l4_global_id_of (thread1);
  l4_thread_id_t global2 = l4_global_id_of (thread2);

  return global1.raw == global2.raw;
}
#endif


_L4_EXTERN_INLINE l4_word_t
l4_is_nil_thread (l4_thread_id_t thread)
{
  return thread.raw == 0;
}


_L4_EXTERN_INLINE l4_word_t
l4_is_local_id (l4_thread_id_t thread)
{
  return thread._all_zero == 0;
}


_L4_EXTERN_INLINE l4_word_t
l4_is_global_id (l4_thread_id_t thread)
{
  return thread._all_zero != 0;
}


_L4_EXTERN_INLINE l4_thread_id_t
l4_myself (void)
{
  return l4_my_global_id ();
}

#endif	/* l4/thread.h */
